﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.8
@EndOfDesignText@
Sub Class_Globals
	
	Private fx As JFX
	Private nativeMe, lc As JavaObject
	
	Public LPosition_InsideNW As Int
	Public LPosition_InsideNE As Int
	Public LPosition_InsideSE As Int
	Public LPosition_InsideSW As Int
	Public LPosition_InsideN As Int
	Public LPosition_InsideS As Int
	Public LPosition_OutsideS As Int
	
	Public LLayout_Horizontal As Int
	Public LLayout_Vertical As Int
	
End Sub

'Initializes the object
'title = Chart Title
'xAxisTitle = X-Axis Title
'yAxisTitle = Y-Axis Title
'seriesName = name of the series thta will be plotted
'xdata() = array of double with x-axis values to be plotted
'ydata() = array of double with y-axis values to be plotted
Public Sub Initialize (title As String, xAxisTitle As String, yAxisTitle As String, seriesName As String, xdata() As Double, ydata() As Double) As JavaObject

	LPosition_InsideNW = 1
	LPosition_InsideNE = 2
	LPosition_InsideSE = 3
	LPosition_InsideSW = 4
	LPosition_InsideN = 5
	LPosition_InsideS = 6
	LPosition_OutsideS = 7
	
	LLayout_Horizontal = 1
	LLayout_Vertical = 2
	
	nativeMe = Me
	lc = nativeMe.RunMethod("initRTLC", Array(title, xAxisTitle, yAxisTitle, seriesName, xdata, ydata))
	Return lc
	
End Sub


public Sub updateLC(xdata() As Double, ydata() As Double)
	
	nativeMe.RunMethod("updateLC", Array(xdata, ydata))
	
End Sub

'set the chart title font
public Sub setChartTitleFont(ttlfnt As JavaObject)
	
	nativeMe.RunMethod("setChartTitleFont", Array(ttlfnt))
	
End Sub

'set the font of the axis tick labels
public Sub setAxisTickLabelsFont(ttlfnt As JavaObject)
	
	nativeMe.RunMethod("setAxisTickLabelsFont", Array(ttlfnt))
	
End Sub

'set the chart axis title font
public Sub setAxisTitleFont(ttlfnt As JavaObject)
	
	nativeMe.RunMethod("setAxisTitleFont", Array(ttlfnt))
	
End Sub

'set the background color of the plot area
public Sub setPlotBackgroundColor(backColor As JavaObject)
	
	nativeMe.RunMethod("setPlotBackgroundColor", Array(backColor))
	 
End Sub

'set the border color of the plot area
public Sub setPlotBorderColor(plotBorderColor As JavaObject)
	
	nativeMe.RunMethod("setPlotBorderColor", Array(plotBorderColor))
	 
End Sub

'set the text color of the lables
public Sub setAxisTickLabelsColor(labelFontColor As JavaObject)
	
	nativeMe.RunMethod("setAxisTickLabelsColor", Array(labelFontColor))
	
End Sub

'set the axis tick mark colors
public Sub setAxisTickMarksColor(labelFontColor As JavaObject)
	
	nativeMe.RunMethod("setAxisTickMarksColor", Array(labelFontColor))
	
End Sub

'set the legend position
public Sub setLegendPosition(position As Int)
	
	nativeMe.RunMethod("setLegendPosition", Array(position))
	
End Sub

'set the layout of the Legend to Vertical or Horizontal
public Sub setLegendLayout(layout As Int)
	
	nativeMe.RunMethod("setLegendLayout", Array(layout))
	
End Sub

'make the legend visible / not visible
'default value is true
public Sub setLegendVisible(visible As Boolean)
	
	nativeMe.RunMethod("setLegendVisible", Array(visible))
	
End Sub

'set the background color of the legend
Public Sub setLegendBackgroundColor(lbgc As JavaObject)
	
	nativeMe.RunMethod("setLegendBackgroundColor", Array(lbgc))
	
End Sub

'set the border color of the legend
Public Sub setLegendBorderColor(lbc As JavaObject)
	
	nativeMe.RunMethod("setLegendBorderColor", Array(lbc))
	
End Sub

'set the font of the legend
Public Sub setLegendFont(fnt As JavaObject)
	
	nativeMe.RunMethod("setLegendFont", Array(fnt))
	
End Sub

'Sets the content size of the plot inside the plot area of the chart. To fill the area 100%, use a value of 1.0.
'The default value is 0.9
public Sub setPlotContentSize (size As Double)
	
	nativeMe.RunMethod("setPlotContentSize", Array(size))
	
End Sub

'set the background color of the title box
Public Sub setChartTitleBoxBackgroundColor(ctbbc As JavaObject)
	nativeMe.RunMethod("setChartTitleBoxBackgroundColor", Array(ctbbc))
End Sub

'set the color of the title box	border
Public Sub setChartTitleBoxBorderColor(ccbbc As JavaObject)
	nativeMe.RunMethod("setChartTitleBoxBorderColor", Array(ccbbc))
End Sub


'set the TitleBoxVisible to true / false
Public Sub setChartTitleBoxVisible(visible As Boolean)
	
	nativeMe.RunMethod("setChartTitleBoxVisible", Array(visible))
	
End Sub

'set the tooltip background color
Public Sub setToolTipBackgroundColor (ttbgc As JavaObject)
	
	nativeMe.RunMethod("setToolTipBackgroundColor", Array(ttbgc))
	
End Sub

'set the tooltip border color
Public Sub setToolTipBorderColor (ttbc As JavaObject)
	
	nativeMe.RunMethod("setToolTipBorderColor", Array(ttbc))
	
End Sub

'set the font of the tooltip
Public Sub setToolTipFont(fnt As JavaObject)
	
	nativeMe.RunMethod("setToolTipFont", Array(fnt))
	
End Sub

'set tooltips enabled
'the default value is false 
public Sub setToolTipsEnabled (tooltipEnabled As Boolean)
	
	nativeMe.RunMethod("setToolTipEnabled", Array(tooltipEnabled))
	
End Sub

'Set the chart font color. Includes: Chart title, axes label, legend
Public Sub setChartFontColor(chartFontColor As JavaObject)
	
	nativeMe.RunMethod("setChartFontColor", Array(chartFontColor))
	
End Sub

'Set the decimal pattern of the X-Axis values
Public Sub setXAxisDecimalPattern(pattern As String)
	
	nativeMe.RunMethod("setXAxisDecimalPattern", Array(pattern))
	
End Sub

'Set the decimal pattern of the X-Axis values
Public Sub setYAxisDecimalPattern(pattern As String)
	
	nativeMe.RunMethod("setYAxisDecimalPattern", Array(pattern))
	
End Sub

'Set the angle/rotation of the x-axis labels
Public Sub setXAxisLabelRotation(angle As Int)
	
	nativeMe.RunMethod("setXAxisLabelRotation", Array(angle))
	
End Sub

'Set the visibility of the X-Axis ticks
Public Sub setXAxisTicksVisible(visible As Boolean)
	
	nativeMe.RunMethod("setXAxisTicksVisible", Array(visible))
	
End Sub

'Set the visibility of the Y-Axis ticks
Public Sub setYAxisTicksVisible(visible As Boolean)
	
	nativeMe.RunMethod("setYAxisTicksVisible", Array(visible))
	
End Sub

'Set the length of the tick marks in pixels
Public Sub setAxisTickMarkLength(tl As Int)
	
	nativeMe.RunMethod("setAxisTickMarkLength", Array(tl))
	
End Sub


Public Sub setAxisTicksLineVisible(vis As Boolean)
	
	nativeMe.RunMethod("setAxisTicksLineVisible", Array(vis))
	
End Sub

'sets the margin (in pixels) around the plot area
Public Sub setPlotMargin(margin As Int)
	
	nativeMe.RunMethod("setPlotMargin", Array(margin))
	
End Sub


'set visibility of the X-Axis title
Public Sub setXAxisTitleVisible(vis As Boolean)
	
	nativeMe.RunMethod("setXAxisTitleVisible", Array(vis))
	
End Sub


'set visibility of the Y-Axis title
Public Sub setYAxisTitleVisible(vis As Boolean)
	
	nativeMe.RunMethod("setYAxisTitleVisible", Array(vis))
	
End Sub


#if Java


import org.knowm.xchart.QuickChart;
import org.knowm.xchart.SwingWrapper;
import org.knowm.xchart.XYChart;
import javafx.embed.swing.SwingNode;
import org.knowm.xchart.XChartPanel;
import javafx.scene.layout.Pane;

import java.awt.Font;
import java.awt.Color;
import org.knowm.xchart.style.Styler.LegendPosition;
import org.knowm.xchart.style.Styler;


  XChartPanel chartPanel;
  XYChart chart;


  public Object initRTLC(String title, String xAxisTitle, String yAxisTitle, String seriesName, double[] xdata, double[] ydata) {
  
      chart =
        QuickChart.getChart(
            title, xAxisTitle, yAxisTitle, seriesName, xdata, ydata);
			

	  SwingNode swingNode = new SwingNode();	
      chartPanel = new XChartPanel(chart);
      swingNode.setContent(chartPanel);	
	  Pane pane = new Pane();
	  pane.getChildren().add(swingNode);

	  return pane;
 
  }

  public void updateLC(double[] xdata, double[] ydata) {

	chart.updateXYSeries("sine", xdata, ydata, null);	
	chartPanel.repaint();

  }	
  
  	public void setChartTitleFont(Font titleFont) {
		chart.getStyler().setChartTitleFont(titleFont);
		
	}	
	
  	public void setAxisTitleFont(Font titleFont) {
		chart.getStyler().setAxisTitleFont(titleFont);
		
	}		
	
  	public void setAxisTickLabelsFont(Font titleFont) {
		chart.getStyler().setAxisTickLabelsFont(titleFont);
		
	}		
	
	public void setPlotBackgroundColor(Color backGroundColor) {
		chart.getStyler().setPlotBackgroundColor(backGroundColor);	
	}	
	
	public void setPlotBorderColor(Color borderColor) {
		chart.getStyler().setPlotBorderColor(borderColor);	
	}
	
	public void setAxisTickMarksColor(Color borderColor) {
		chart.getStyler().setAxisTickMarksColor(borderColor);	
	}	
	
	private int pos = 7;
	public void setLegendPosition(int pos) {
		this.pos = pos;
		if (pos == 1) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideNW);
		if (pos == 2) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideNE);
		if (pos == 3) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideSE);
		if (pos == 4) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideSW);
		if (pos == 5) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideN);
		if (pos == 6) chart.getStyler().setLegendPosition(Styler.LegendPosition.InsideS);
		if (pos == 7) chart.getStyler().setLegendPosition(Styler.LegendPosition.OutsideS);
		
	}	
	
	int layout = 1;
	public void setLegendLayout(int layout) {
		this.layout = layout;
		if (layout == 1) chart.getStyler().setLegendLayout(Styler.LegendLayout.Horizontal);
		if (layout == 2) chart.getStyler().setLegendLayout(Styler.LegendLayout.Vertical);
	}
	
	private boolean visible = true;
	public void setLegendVisible (boolean visible) {
		this.visible = visible;
		chart.getStyler().setLegendVisible(visible);
	}	
	
	
	public void setLegendBackgroundColor(Color lbgc) {
		chart.getStyler().setLegendBackgroundColor(lbgc);
	}
	
	public void setLegendBorderColor(Color lbc) {
		chart.getStyler().setLegendBorderColor(lbc);
	}
	
	public void setLegendFont(Font legendFont) {
		chart.getStyler().setLegendFont(legendFont);
	}	
	
	private double plotContentSize = 0.9;
	public void setPlotContentSize(double plotContentSize) {
		this.plotContentSize = plotContentSize;
		chart.getStyler().setPlotContentSize(plotContentSize);	
	}	
	
	public void setChartTitleBoxBackgroundColor(Color ctbbc) {
		chart.getStyler().setChartTitleBoxBackgroundColor(ctbbc);
	}
	
	public void setChartTitleBoxBorderColor(Color ccbbc) {
		chart.getStyler().setChartTitleBoxBorderColor(ccbbc);
	}
	
	public void setChartTitleBoxVisible(boolean visible) {
		chart.getStyler().setChartTitleBoxVisible(visible);
	}	
	
	public void setToolTipBackgroundColor(Color ttbgc) {
		chart.getStyler().setToolTipBackgroundColor(ttbgc);
	}
	
	public void setToolTipBorderColor(Color ttbc) {
		chart.getStyler().setToolTipBorderColor(ttbc);
	}
	
	public void setToolTipFont(Font toolTipFont) {
		chart.getStyler().setToolTipFont(toolTipFont);
	}	
	
	private boolean tooltipEnabled = false;
	public void setToolTipEnabled(boolean tooltipEnabled) {
	 	this.tooltipEnabled = tooltipEnabled;
		chart.getStyler().setToolTipsEnabled(tooltipEnabled);	
	}	
	
	public void setChartFontColor(Color chartFontColor) {
		chart.getStyler().setChartFontColor(chartFontColor);
	}	
	
	public void setXAxisDecimalPattern(String pattern) {
		chart.getStyler().setXAxisDecimalPattern(pattern);
	}		
	
	public void setYAxisDecimalPattern(String pattern) {
		chart.getStyler().setYAxisDecimalPattern(pattern);
		chartPanel.repaint();
	}	
	
	public void setXAxisLabelRotation(int angle) {
		chart.getStyler().setXAxisLabelRotation(angle);
	}
	
	public void setXAxisTicksVisible(boolean visible) {
		chart.getStyler().setXAxisTicksVisible(visible);
	}
	
	public void setYAxisTicksVisible(boolean visible) {
		chart.getStyler().setYAxisTicksVisible(visible);
	}
	
	public void setAxisTickMarkLength(int tl) {
		chart.getStyler().setAxisTickMarkLength(tl);    //in pixels
	}
	
	public void setAxisTicksLineVisible(boolean vis) {
		chart.getStyler().setAxisTicksLineVisible(vis);
	}
	
	public void setPlotMargin(int margin) {
		chart.getStyler().setPlotMargin(margin);   //in pixels
	}
	
	public void setYAxisTitleVisible(boolean vis) {
		chart.getStyler().setYAxisTitleVisible(true);
		chartPanel.repaint();
	}
	
	public void setXAxisTitleVisible(boolean vis) {
		chart.getStyler().setYAxisTitleVisible(true);
		chartPanel.repaint();
	}	
		
	
	public void setAxisTickLabelsColor(Color labelsFontColor) {
		chart.getStyler().setAxisTickLabelsColor(labelsFontColor);	
	}		

#End If